package com.cpop.api.cloudDb.handler;

import com.alibaba.fastjson.JSONObject;
import com.cpop.api.cloudDb.core.constant.CloudDbUrl;
import com.cpop.api.cloudDb.core.dto.CloudClassDto;
import com.cpop.api.cloudDb.core.dto.CloudClassStudentDto;
import com.cpop.api.cloudDb.core.dto.CloudCourseDto;
import com.cpop.common.utils.StringUtils;
import com.cpop.core.base.exception.UtilException;
import com.mybatisflex.core.paginate.Page;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.web.client.RestTemplate;

import java.util.List;

/**
 * 云班级工具类
 * @author DB
 * @version 1.0.0
 * @since 2024-01-10 10:05
 */
@Component
public class CloudClassHandler {

    @Autowired
    private RestTemplate restTemplate;

    /**
     * 获取班级分页
     * @author DB
     * @since 2024/1/9
     * @param pageNum 分页参数
     * @param pageSize 分页参数
     * @param startDate 开始日期
     * @param endDate 结束日期
     * @param storeId 云校区id
     * @param classId 云班级id
     * @return Page<CloudCustomerDto>
     */
    public Page<CloudClassDto> getClassPage(Integer pageNum, Integer pageSize, String startDate, String endDate, String storeId, String classId) {
        JSONObject jsonBody = new JSONObject();
        jsonBody.put("_type", "classes");
        //分页参数
        jsonBody.put("page", pageNum);
        jsonBody.put("limit", pageSize);
        //开始日期结束日期
        if (StringUtils.isNotBlank(startDate) && StringUtils.isNotBlank(endDate)) {
            jsonBody.put("startTime", startDate);
            jsonBody.put("endTime", endDate);
        }
        if (StringUtils.isNotBlank(classId)){
            jsonBody.put("classId", classId);
        }
        //校区id
        jsonBody.put("storeId", storeId);
        JSONObject jsonObject = restTemplate.postForObject(CloudDbUrl.DATA_CLOUD, jsonBody, JSONObject.class);
        Page<CloudClassDto> page = Page.of(pageNum, pageSize);
        if (jsonObject != null) {
            if (jsonObject.getBoolean("success")) {
                List<CloudClassDto> courseDtoList = jsonObject.getJSONArray("list").toJavaList(CloudClassDto.class);
                page.setRecords(courseDtoList);
                page.setTotalPage(jsonObject.getInteger("total"));
                page.setTotalRow(jsonObject.getInteger("total"));
                return page;
            } else {
                throw new UtilException(jsonObject.getString("error"));
            }
        } else {
            return page;
        }
    }

    /**
     * 获取班级学员分页
     * @author DB
     * @since 2024/1/9
     * @param pageNum 分页参数
     * @param pageSize 分页参数
     * @param startDate 开始日期
     * @param endDate 结束日期
     * @param storeId 云校区id
     * @param classId 云班级id
     * @return Page<CloudCustomerDto>
     */
    public Page<CloudClassStudentDto> getClassStudentPage(Integer pageNum, Integer pageSize, String startDate, String endDate, String storeId, String classId) {
        JSONObject jsonBody = new JSONObject();
        jsonBody.put("_type", "classesStudent");
        //分页参数
        jsonBody.put("page", pageNum);
        jsonBody.put("limit", pageSize);
        //开始日期结束日期
        if (StringUtils.isNotBlank(startDate) && StringUtils.isNotBlank(endDate)) {
            jsonBody.put("startTime", startDate);
            jsonBody.put("endTime", endDate);
        }
        if (StringUtils.isNotBlank(classId)){
            jsonBody.put("classId", classId);
        }
        //校区id
        jsonBody.put("storeId", storeId);
        JSONObject jsonObject = restTemplate.postForObject(CloudDbUrl.DATA_CLOUD, jsonBody, JSONObject.class);
        Page<CloudClassStudentDto> page = Page.of(pageNum, pageSize);
        if (jsonObject != null) {
            if (jsonObject.getBoolean("success")) {
                List<CloudClassStudentDto> courseDtoList = jsonObject.getJSONArray("list").toJavaList(CloudClassStudentDto.class);
                page.setRecords(courseDtoList);
                page.setTotalPage(jsonObject.getInteger("total"));
                page.setTotalRow(jsonObject.getInteger("total"));
                return page;
            } else {
                throw new UtilException(jsonObject.getString("error"));
            }
        } else {
            return page;
        }
    }
}
